from algorithms.graph import *


def dfs_recurse_path(g, s, t):
    for v in g.vertices:
        v.visited = False
    return reversed(path(s, t))


def path(v, t):
    if v == t:
        return [v]  # This alone is not sufficient.
    v.visited = True
    p = None
    for w in v.neighbours:
        if not w.visited:
            p = path(w, t)
            if p is not None:
                # Found a path, so we don't need to explore
                # any other nodes.
                break
    if p is not None:
        p += [v]
    return p


ret = dfs_recurse_path(simple_graph_3, simple_graph_3.vertices[2], simple_graph_3.vertices[7])
print(f"Path : ")
for x in ret:
    print(x)
