from algorithms.graph import *


def dfs(g, s):
    for v in g.vertices:
        v.seen = False
    # The stack initially contains a single element with 0 counter.
    toexplore = [(s, 0)]
    s.seen = True

    while len(toexplore) > 0:
        v, cnt = toexplore.pop()  # Now visiting vertex v.
        if cnt == 0:
            print(f"Visiting: {v}")
        while cnt < len(v.neighbours):
            w = v.neighbours[cnt]
            cnt += 1
            if not w.seen:
                # Add the old node to the stack with increased counter.
                toexplore.append((v, cnt))
                # Add the new node to the stack with 0 counter.
                toexplore.append((w, 0))
                w.seen = True
                # Once we find the first node we should terminate.
                break


dfs(simple_graph, simple_graph.vertices[0])
